require 'ipaddr'
require 'log_analysis/model/user_identity'

module UserIdentification
  class Error < StandardError; end
  # Your code goes here...

  def self.execute(cleaned_data)
    cleaned_data.each_with_object([]) do |record, arr|
      user = arr.detect { |i| i == record.user }
      if user
        user.records.push(record)
      else
        record.user.records = [record]
        arr << record.user
      end
    end
  end
end
