require 'log_analysis/version'

module Intepretation
  class Error < StandardError; end
  # Your code goes here...

  def self.execute(data_mining)
    map_uri = File.read(LogAnalysis::MAP_URI_FILE_PATH).split(' ')
    move_data

    data_mining.map do |data|
      seq, sub, rea = data
      [seq.map { |i| map_uri[i.to_i] }, sub.map { |i| map_uri[i.to_i] }, rea]
    end
  end

  def self.move_data
    return unless File.directory?(LogAnalysis::DATA_PATH)

    system('mv', "*_#{Time.now.strftime('%Y%m%d')}.txt", LogAnalysis::DATA_PATH)
  end
end
