require 'active_support/core_ext/module/delegation'
require 'log_analysis/model/record'
require 'useragent'

class UserIdentity
  attr_accessor :host, :user_agent, :records

  delegate :browser, :version, :os, :platform, :mobile?, :application, :localization, to: :user_agent

  def initialize(params)
    @host       = params[:host]
    @user_agent = params[:user_agent]
    @records    = params[:records]
  end
end
